function Shat = ReconstructionUsingDCT(filename)

load(filename);

F = size(S, 1)/3;
P = size(S, 2);
C = 3;
K = 30;
percentage = 0.5;       % %age points missing
isFull = true;          % extrapolate reconstruction in starting/ending frames?

Sd = zeros(3, F*P); 
Sd(1, :) = reshape(S(1:3:end, :), 1, F*P);
Sd(2, :) = reshape(S(2:3:end, :), 1, F*P);
Sd(3, :) = reshape(S(3:3:end, :), 1, F*P);

[W, Rs] = createSyntheticW(Sd, C);
W = W - mean(W, 2)*ones(1, F*P);

[W, indcs] = getIncompleteW(W, percentage);

[RecS, RecR] = TK_freq(W, F, K);        % frequnce-SFM

Sd = Sd - mean(Sd, 2)*ones(1, F*P);
[Y] = findRotation(Sd, RecS);
RecS = Y*RecS;              % rotation alignment of recovered struture 

Shat = zeros(3*F, P);
Shat(1:3:end, :) = reshape(RecS(1, :), F, P);
Shat(2:3:end, :) = reshape(RecS(2, :), F, P);
Shat(3:3:end, :) = reshape(RecS(3, :), F, P);

S = zeros(3*F, P);          % Original S is Sd (mean subtracted) now
S(1:3:end, :) = reshape(Sd(1, :), F, P);
S(2:3:end, :) = reshape(Sd(2, :), F, P);
S(3:3:end, :) = reshape(Sd(3, :), F, P);

viewStruct(S, Shat, -31.5, 9);