function [RecS, RecR] = TK_freq(W, F, K)
% function [RecS, RecR, RecSw, frames] = TK_freq(W, F, K, isFull)

P = size(W,2)/F;
C = size(W, 1)/2;

W2 = zeros(2*C, F*P);
Wd = zeros(F, 2*P);
B = zeros(2*C, K*P);

Bd = zeros(K, 2*P);
frames = ones(P,1)*[1,F];

if sum(sum(isnan(W)))    
    Theta = estimateBasisIncompleteW(W, F, K);
%     Theta = idct(eye(F));           % need to change
    Theta = Theta(:, 1:K);

    for c=1:C
        Wd(:, 1:2:end) = reshape(W(2*c-1, :), F, P);
        Wd(:, 2:2:end) = reshape(W(2*c, :), F, P);        
        Wd2 = zeros(F, 2*P);
        
        for j=1:P
            w = Wd(frames(j,1):frames(j,2), 2*j-1:2*j);
            ind = all(~isnan(w), 2);
            wdash = w(ind, :);
            theta = idct(eye(frames(j,2)-frames(j,1)+1));
            theta = theta(:, 1:K);
            thetaDash = theta(ind, :);
            Bd(:, 2*j-1:2*j) = thetaDash\wdash;
            
            Wd2(frames(j,1):frames(j,2), 2*j-1:2*j) = ...
                theta(frames(j,1):frames(j,2), :)*Bd(:, 2*j-1:2*j);
        end
        B(2*c-1, :) = reshape(Bd(:, 1:2:end), 1, K*P);
        B(2*c, :) = reshape(Bd(:, 2:2:end), 1, K*P);
        
        W2(2*c-1, :) = reshape(Wd2(:,1:2:end), 1, F*P);
        W2(2*c, :) = reshape(Wd2(:,2:2:end), 1, F*P);
    end
else
    Theta = estimateBasis(W, F);
    Theta = Theta(:, 1:K);
    for c=1:C
        Wd(:, 1:2:end) = reshape(W(2*c-1, :), F, P);
        Wd(:, 2:2:end) = reshape(W(2*c, :), F, P);
        
        Bd = Theta'*Wd;
        B(2*c-1, :) = reshape(Bd(:, 1:2:end), 1, K*P);
        B(2*c, :) = reshape(Bd(:, 2:2:end), 1, K*P);
        
        Wd2 = Theta*Bd;
        W2(2*c-1, :) = reshape(Wd2(:,1:2:end), 1, F*P);
        W2(2*c, :) = reshape(Wd2(:,2:2:end), 1, F*P);
    end
end

[RecA, RecR] = TK(B);

A = zeros(K, 3*P);
A(:, 1:3:end) = reshape(RecA(1, :), K, P);
A(:, 2:3:end) = reshape(RecA(2, :), K, P);
A(:, 3:3:end) = reshape(RecA(3, :), K, P);

if sum(sum(isnan(W)))
    ShatD = NaN(F, 3*P);
    for j=1:P        
        theta = idct(eye(frames(j,2)-frames(j,1)+1));
        theta = theta(:, 1:K);
        ShatD(frames(j,1):frames(j,2), 3*j-2:3*j) = ...
            theta*A(:, 3*j-2:3*j);
    end
else
    ShatD = Theta*A;
end

RecS(1, :) = reshape(ShatD(:, 1:3:end), 1, F*P);
RecS(2, :) = reshape(ShatD(:, 2:3:end), 1, F*P);
RecS(3, :) = reshape(ShatD(:, 3:3:end), 1, F*P);

% W2 = W2 - mean(W2, 2)*ones(1, F*P);
% [RecSw, RecR] = TK(W2);