function Theta = estimateBasis(W, F)

C = size(W, 1)/2;
P = size(W, 2)/F;

W2 = zeros(F, 2*P*C);
for i=1:C
    j1 = (i-1)*2*P + 1;
    j2 = i*2*P;
    W2(:, j1:2:j2) = reshape(W(2*i-1, :), F, P);
    W2(:, j1+1:2:j2) = reshape(W(2*i, :), F, P);
end

if F<(2*P*C)
    [Theta, D, V] = svd(W2*W2', 0);
else
    [U, D, Theta] = svd(W2', 0);
end
